
//	Metamaxim ModelScope

package Bank;

import com.metamaxim.modelscope.callbacks.*;

public class Account extends Behaviour {

// Update Balance for a Deposit
	public void processCashDeposit(Event event, String subscript) {
		int newBalance = this.getCurrency("Balance") + event.getCurrency("Amount");
		this.setCurrency("Balance", newBalance);
	}

// Update Balance for a Withdraw
	public void processCashWithdraw(Event event, String subscript) {
		int newBalance = this.getCurrency("Balance") - event.getCurrency("Amount");
		this.setCurrency("Balance", newBalance);
	}

// Update Owner for a Change Owner
	public void processChangeOwner(Event event, String subscript) {
		this.setInstance("Owner", event.getInstance("New Owner"));
	}

// Get the Available Funds for the Customer
	public int getAvailableFunds() {
		return this.getInstance("Owner").getCurrency("Total Balance");
	}

}

